sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=69
left=76
tile=1
caption="Lucifer"
tileSpacing=5
End CompInit
Dim TopGroup as group
TopGroup = MakeComponent("group",form1)
CompInit TopGroup
proto="group3"
caption=""
look=2
sizeHControl=0
sizeVControl=0
height=120
tile=1
width=576
visible=1
End CompInit
Dim LuciferContainer as gadget
LuciferContainer = MakeComponent("gadget",TopGroup)
CompInit LuciferContainer
proto="gadget3"
sizeHControl=2
sizeVControl=2
visible=1
End CompInit
LuciferContainer.name="LuciferContainer"
TopGroup.name="TopGroup"
Dim BottomGroup as group
BottomGroup = MakeComponent("group",form1)
CompInit BottomGroup
proto="group4"
caption=""
look=1
sizeVControl=0
height=100
tile=1
tileHAlign=1
tileLayout=1
tileSpacing=5
sizeHControl=2
visible=1
End CompInit
Dim TextGroup as group
TextGroup = MakeComponent("group",BottomGroup)
CompInit TextGroup
proto="group5"
caption=""
sizeHControl=3
sizeVControl=0
tile=1
height=60
visible=1
End CompInit
TextGroup.name="TextGroup"
Dim ButtonGroup as group
ButtonGroup = MakeComponent("group",BottomGroup)
CompInit ButtonGroup
proto="group6"
caption=""
look=1
tile=1
tileSpacing=10
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim YourTurn as button
YourTurn = MakeComponent("button",ButtonGroup)
CompInit YourTurn
proto="button1"
caption="Your Turn"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
YourTurn.name="YourTurn"
Dim NewGameButton as button
NewGameButton = MakeComponent("button",ButtonGroup)
CompInit NewGameButton
proto="button5"
caption="New Game"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
NewGameButton.name="NewGameButton"
ButtonGroup.name="ButtonGroup"
Dim Info as text
Info = MakeComponent("text",BottomGroup)
CompInit Info
proto="text2"
height=58
sizeHControl=2
End CompInit
Info.name="Info"
Info.visible=1
Dim ScoreGroup as group
ScoreGroup = MakeComponent("group",BottomGroup)
CompInit ScoreGroup
proto="group5"
caption=""
look=2
sizeVControl=0
height=70
tileSpacing=3
visible=1
End CompInit
Dim LucifersLabel as label
LucifersLabel = MakeComponent("label",ScoreGroup)
CompInit LucifersLabel
proto="label1"
caption=""
sizeHControl=3
sizeVControl=3
left=8
top=0
visible=1
End CompInit
LucifersLabel.name="LucifersLabel"
Dim spacer1 as spacer
spacer1 = MakeComponent("spacer",ScoreGroup)
CompInit spacer1
proto="spacer1"
look=5
sizeHControl=2
height=10
left=0
top=12
visible=1
End CompInit
spacer1.name="spacer1"
Dim ScoreTitelLabel as label
ScoreTitelLabel = MakeComponent("label",ScoreGroup)
CompInit ScoreTitelLabel
proto="label2"
caption="   "
sizeHControl=3
sizeVControl=3
left=8
top=25
visible=1
End CompInit
ScoreTitelLabel.name="ScoreTitelLabel"
Dim label3 as label
label3 = MakeComponent("label",ScoreGroup)
CompInit label3
proto="label3"
caption="   "
sizeHControl=3
sizeVControl=3
left=8
top=40
visible=1
End CompInit
label3.name="label3"
Dim label4 as label
label4 = MakeComponent("label",ScoreGroup)
CompInit label4
proto="label4"
caption="   "
sizeHControl=3
sizeVControl=3
left=8
top=55
visible=1
End CompInit
label4.name="label4"
ScoreGroup.name="ScoreGroup"
BottomGroup.name="BottomGroup"
Dim GameMenu as popup
GameMenu = MakeComponent("popup",form1)
CompInit GameMenu
proto="popup1"
caption="Game"
visible=1
End CompInit
Dim Mnu_About as button
Mnu_About = MakeComponent("button",GameMenu)
CompInit Mnu_About
proto="button3"
caption="About Lucifer"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Mnu_About.name="Mnu_About"
Dim Mnu_HowToPlay as button
Mnu_HowToPlay = MakeComponent("button",GameMenu)
CompInit Mnu_HowToPlay
proto="button4"
caption="How To Play"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Mnu_HowToPlay.name="Mnu_HowToPlay"
Dim EindeButton as button
EindeButton = MakeComponent("button",GameMenu)
CompInit EindeButton
proto="button2"
caption="Einde"
sizeHControl=3
sizeVControl=3
enabled=0
visible=1
End CompInit
EindeButton.name="EindeButton"
GameMenu.name="GameMenu"
Dim OptionsMenu as popup
OptionsMenu = MakeComponent("popup",form1)
CompInit OptionsMenu
proto="popup2"
caption="Options"
left=0
top=0
visible=1
End CompInit
Dim HoeveelLucifersToggle as toggle
HoeveelLucifersToggle = MakeComponent("toggle",OptionsMenu)
CompInit HoeveelLucifersToggle
proto="toggle1"
caption="Show Number Of Matches"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
HoeveelLucifersToggle.name="HoeveelLucifersToggle"
Dim ScoreAanToggle as toggle
ScoreAanToggle = MakeComponent("toggle",OptionsMenu)
CompInit ScoreAanToggle
proto="toggle2"
caption="Display score"
sizeHControl=3
status=1
sizeVControl=3
visible=1
End CompInit
ScoreAanToggle.name="ScoreAanToggle"
OptionsMenu.name="OptionsMenu"
form1.name="form1"
form1.height=270
form1.width=582
Dim dialog1 as dialog
dialog1 = MakeComponent("dialog","app")
CompInit dialog1
proto="dialog1"
left=593
top=23
tile=1
tileHAlign=2
helpContext=""
caption=""
sizeHControl=0
End CompInit
Dim picture1 as picture
picture1 = MakeComponent("picture",dialog1)
CompInit picture1
proto="picture1"
width=40
height=93
visible=1
End CompInit
picture1.name="picture1"
picture1.graphic=GetComplex(0)
dialog1.height=130
dialog1.width=56
dialog1.name="dialog1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

	dim Opmerking as string
	dim SpelScore1 as string
	dim SpelScore2 as string
	dim KlaarGezet as integer
	dim Teller as Integer
	dim AantalLucifers as integer
	dim SpelerZet as Integer
	dim Speler as Integer
	dim Verwijderen as Integer
	dim WieWint as Integer
	dim Mens as integer
	dim PC as integer

	AantalLucifers = 15

	VoerOptiesUit()

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1
end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub gadget1_mouse(self as gadget, action as integer, flag as integer, X as integer, Y as integer, modifier as integer)
	Info.text = ""
	if action = 1
		if Speler > 3 then
			Opmerking = ""
			Opmerking = "You can't remove more than 3 matches."
			exit sub
		end if

		SpelerZet = 1
		Speler = Speler + 1
		AantalLucifers = AantalLucifers - 1
		self.Redraw()

		if AantalLucifers = 0 then
			WieWint = 1
		end if
	end if
end sub

sub gadget3_draw(self as gadget)
	dim x as integer
	dim y as integer
	for x = 1 to AantalLucifers
			self.DrawImage(picture1.graphic,y,15)
			y = y + 35
	next x
end sub

sub button4_pressed(self as button)
	Opmerking = "You are playing this game againgst the computer. "
	Opmerking = Opmerking + "Your start the game by clicking on the 'New Game' button. "
	Opmerking = Opmerking + "Then you remove 1, 2 or 3 matches by clicking on them. \r"
	Opmerking = Opmerking + "When done, you click on 'Your Turn' to let the computer play. \r"
	Opmerking = Opmerking + "The player who has to remove the last match, looses the game. "
	Info.text = Opmerking
end sub

sub button5_pressed(self as button)
	Info.text = ""
	if AantalLucifers = 1 then
		Info.text = "Be a good sport! Remove the last one too!"
		exit sub
	end if
	
	if KlaarGezet = 0 then
		AantalLucifers = 15
		KlaarGezet = 1
	end if
	LuciferContainer.Redraw()
	AantalLucifers = 15
	Speler = 1
	SpelerZet = 0

	VoerOptiesUit()

end sub

sub button1_pressed(self as button)
	Info.text = ""
	if AantalLucifers = 0 then
			Opmerking = "Click on 'New Game' to play again."
			Info.text = Opmerking
			exit sub
		end if

		if SpelerZet = 0 then
			Opmerking = "Remove at least 1 match."
			Info.text = Opmerking
			exit sub
		end if

		if AantalLucifers = 1 then
			WieWint = 0
			EindeSpel()
		else
			dim matchstring as string
			ComputerZet()
			Speler = 1
			SpelerZet = 0
			if Verwijderen = 1 then
				matchstring = " match. "
			else
				matchstring = " matches. "
			end if
			Opmerking = "The computer has removed " + str(Verwijderen) + matchstring + "It's your turn again."
			Verwijderen = 0
			Info.text = Opmerking
		end if

end sub

sub button3_pressed(self as button)
	Opmerking = "Lucifer Game \r"
	Opmerking = Opmerking + "\r"
	Opmerking = Opmerking + "NewBasic test\r"
	Opmerking = Opmerking + "1998 Peter Vanspauwen"
	Info.text = Opmerking
end sub

sub button2_pressed(self as button)
	
end sub

sub gadget3_mouse(self as gadget, action as integer, flag as integer, X as integer, Y as integer, modifier as integer)
if KlaarGezet = 1
	if action = 1
		Info.text = ""
		if Speler > 3 then
			Opmerking = "You can't remove more than 3 matches!"
			Info.text = Opmerking
			exit sub
		end if

		SpelerZet = 1
		Speler = Speler + 1
		AantalLucifers = AantalLucifers - 1
		LuciferContainer.Redraw()

		if AantalLucifers = 0 then
			WieWint = 1
			EindeSpel()
		end if
		VoerOptiesUit()
	end if	

end if		
end sub

sub ComputerZet()
	Info.text = ""
	Verwijderen = (AantalLucifers - 1) Mod (4)
	If Verwijderen = 0 then 
		Verwijderen = int(3 * Rnd()) + 1
	end if
	ComputerHaaltWeg()

end sub

sub ComputerHaaltWeg()
	AantalLucifers = AantalLucifers - Verwijderen
	LuciferContainer.Redraw()
	VoerOptiesUit()

end sub

sub EindeSpel()
	if WieWint = 1 then
		Opmerking = "You lost!\r"
		Opmerking = Opmerking + "There's a trick to beat the computer. \r"
		Opmerking = Opmerking + "The same trick the computer used to beat you!\r"
		Opmerking = Opmerking + "Don't give up! Click on 'New Game' and try again!"
		PC = PC + 1

	else
		Opmerking = "Gee! You won! \r"
		Opmerking = Opmerking + "Click on 'New Game' for a next round."
		Mens = Mens + 1
	end if
	Info.text = Opmerking
	AantalLucifers = 0
	KlaarGezet = 0
	LuciferContainer.Redraw()

	VoerOptiesUit()

end sub

sub toggle1_changed(self as toggle)
	VoerOptiesUit()
end sub

sub GeefScore()

	SpelScore1 = "Player     : " + str(Mens)
	SpelScore2 = "Computer: " + str(PC)
	if ScoreAanToggle.status = 1
		ScoreTitelLabel.caption = "Score: "
		label3.caption = SpelScore1
		label4.caption = SpelScore2
	else
		ScoreTitelLabel.caption = "         "
		label3.caption = "           "
		label4.caption = "           "
	end if

end sub

sub toggle2_changed(self as toggle)
	VoerOptiesUit()
end sub

sub VoerOptiesUit()
	dim matchstring as string
	if AantalLucifers = 1
		matchstring = " match    "
	else
		matchstring = " matches   "
	end if
	if HoeveelLucifersToggle.status = 1
		LucifersLabel.caption = str(AantalLucifers) + matchstring
		spacer1.enabled = 1
		spacer1.visible = 1

	else
		ScoreGroup.visible = 0
		spacer1.visible = 0
		spacer1.enabled = 0
		LucifersLabel.caption = ""
		ScoreGroup.visible = 1
	end if

	SpelScore1 = "Player     : " + str(Mens)
	SpelScore2 = "Computer: " + str(PC)
	if ScoreAanToggle.status = 1
		ScoreTitelLabel.caption = "Score: "
		label3.caption = SpelScore1
		label4.caption = SpelScore2
	else
		ScoreGroup.visible = 0
		ScoreTitelLabel.caption = ""
		label3.caption = ""
		label4.caption = ""
		ScoreGroup.visible = 1
	end if

end sub

