sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10



REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=173
left=99
tile=1
tileVAlign=2
caption="ColorWiz 0.2 216 Colors"
helpContext="TOC"
helpFile="colViz"
End CompInit
Dim group1 as group
group1 = MakeComponent("group",form1)
CompInit group1
proto="group1"
caption="Color - Preview"
look=2
sizeHControl=3
tileLayout=1
tile=1
sizeVControl=3
visible=1
End CompInit
Dim group11 as group
group11 = MakeComponent("group",group1)
CompInit group11
proto="group11"
caption="Color - Preview"
look=1
tile=1
sizeHControl=3
sizeVControl=2
visible=1
End CompInit
Dim clipper1 as clipper
clipper1 = MakeComponent("clipper",group11)
CompInit clipper1
proto="clipper1"
sizeHControl=0
sizeVControl=0
width=128
height=95
tile=1
visible=1
End CompInit
Dim Preview as gadget
Preview = MakeComponent("gadget",clipper1)
CompInit Preview
proto="Preview"
width=128
height=95
visible=1
End CompInit
Preview.name="Preview"
clipper1.name="clipper1"
group11.name="group11"
Dim group12 as group
group12 = MakeComponent("group",group1)
CompInit group12
proto="group12"
caption="Color - Scheme"
look=1
tile=1
sizeHControl=3
sizeVControl=2
visible=1
End CompInit
Dim Color16_but as button
Color16_but = MakeComponent("button",group12)
CompInit Color16_but
proto="Color16_but"
caption=""
sizeHControl=0
sizeVControl=3
width=125
visible=1
End CompInit
Color16_but.graphic=GetComplex(0)
Color16_but.name="Color16_but"
Dim Color216_but as button
Color216_but = MakeComponent("button",group12)
CompInit Color216_but
proto="Color216_but"
caption=""
sizeHControl=0
sizeVControl=3
width=125
visible=1
End CompInit
Color216_but.graphic=GetComplex(1)
Color216_but.name="Color216_but"
Dim ColorMil_but as button
ColorMil_but = MakeComponent("button",group12)
CompInit ColorMil_but
proto="ColorMil_but"
caption=""
sizeHControl=0
sizeVControl=3
width=125
visible=1
End CompInit
ColorMil_but.graphic=GetComplex(2)
ColorMil_but.name="ColorMil_but"
group12.name="group12"
group1.name="group1"
Dim group2 as group
group2 = MakeComponent("group",form1)
CompInit group2
proto="group2"
caption="RGB - Selector"
look=1
tile=1
tileLayout=1
tileHAlign=1
sizeHControl=2
sizeVControl=3
visible=1
End CompInit
Dim group5 as group
group5 = MakeComponent("group",group2)
CompInit group5
proto="group5"
caption="group5"
look=2
tile=1
tileLayout=1
visible=1
End CompInit
group5.name="group5"
Dim gadget2 as gadget
gadget2 = MakeComponent("gadget",group2)
CompInit gadget2
proto="gadget2"
visible=1
End CompInit
gadget2.name="gadget2"
Dim number1 as number
number1 = MakeComponent("number",group2)
CompInit number1
proto="number1"
caption=""
maximum=255
increment=51
displayFormat=0
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
number1.name="number1"
Dim gadget3 as gadget
gadget3 = MakeComponent("gadget",group2)
CompInit gadget3
proto="gadget3"
visible=1
End CompInit
gadget3.name="gadget3"
Dim number2 as number
number2 = MakeComponent("number",group2)
CompInit number2
proto="number2"
caption=""
maximum=255
increment=51
displayFormat=0
sizeVControl=3
sizeHControl=3
visible=1
End CompInit
number2.name="number2"
Dim gadget4 as gadget
gadget4 = MakeComponent("gadget",group2)
CompInit gadget4
proto="gadget4"
visible=1
End CompInit
gadget4.name="gadget4"
Dim number3 as number
number3 = MakeComponent("number",group2)
CompInit number3
proto="number3"
caption=""
maximum=255
increment=51
displayFormat=0
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
number3.name="number3"
group2.name="group2"
Dim group3 as group
group3 = MakeComponent("group",form1)
CompInit group3
proto="group3"
caption="SDK - Color - Constant"
look=1
sizeHControl=2
sizeVControl=3
tile=1
tileLayout=1
tileHAlign=1
visible=1
End CompInit
Dim text1 as text
text1 = MakeComponent("text",group3)
CompInit text1
proto="text1"
height=18
maxLines=1
filter=36
readOnly=1
maxChars=30
look=3
width=140
fontSize=14
End CompInit
text1.name="text1"
text1.visible=1
Dim group13 as group
group13 = MakeComponent("group",group3)
CompInit group13
proto="group13"
caption="group13"
look=2
tile=1
tileLayout=1
tileSpacing=29
visible=1
End CompInit
Dim gadget6 as gadget
gadget6 = MakeComponent("gadget",group13)
CompInit gadget6
proto="gadget6"
visible=1
End CompInit
gadget6.name="gadget6"
Dim number5 as number
number5 = MakeComponent("number",group13)
CompInit number5
proto="number5"
caption=""
displayFormat=0
sizeVControl=3
maximum=255
visible=1
End CompInit
number5.name="number5"
group13.name="group13"
group3.name="group3"
Dim group4 as group
group4 = MakeComponent("group",form1)
CompInit group4
proto="group4"
caption="NewBasic Colorstring"
look=1
sizeHControl=2
sizeVControl=3
tile=1
tileLayout=1
tileHAlign=1
visible=1
End CompInit
Dim text2 as text
text2 = MakeComponent("text",group4)
CompInit text2
proto="text2"
height=18
maxLines=1
filter=36
width=105
readOnly=1
maxChars=20
look=2
bgColor=-16724788
fontSize=14
End CompInit
text2.name="text2"
text2.Color=-171
text2.visible=1
Dim group8 as group
group8 = MakeComponent("group",group4)
CompInit group8
proto="group8"
caption="group8"
look=2
tile=1
tileLayout=1
tileSpacing=29
visible=1
End CompInit
Dim gadget5 as gadget
gadget5 = MakeComponent("gadget",group8)
CompInit gadget5
proto="gadget5"
visible=1
End CompInit
gadget5.name="gadget5"
Dim number4 as number
number4 = MakeComponent("number",group8)
CompInit number4
proto="number4"
caption=""
maximum=255
sizeHControl=3
sizeVControl=3
value=255
displayFormat=0
visible=1
End CompInit
number4.name="number4"
group8.name="group8"
group4.name="group4"
Dim popup1 as popup
popup1 = MakeComponent("popup",form1)
CompInit popup1
proto="popup1"
caption="File"
left=100
top=172
tileSpacing=2
tileHInset=1
tileVInset=1
visible=1
End CompInit
Dim Colorlist as button
Colorlist = MakeComponent("button",popup1)
CompInit Colorlist
proto="Colorlist"
caption="Colorlist"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Colorlist.name="Colorlist"
Dim button4 as button
button4 = MakeComponent("button",popup1)
CompInit button4
proto="button4"
caption="Info"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button4.name="button4"
popup1.name="popup1"
form1.name="form1"
form1.height=308
form1.width=289
form1.focus=number1
Dim Info_dia as dialog
Info_dia = MakeComponent("dialog","app")
CompInit Info_dia
proto="Info_dia"
left=398
top=79
tile=1
tileVAlign=2
caption="Info"
helpContext=""
sizeHControl=3
sizeVControl=3
End CompInit
Dim text3 as text
text3 = MakeComponent("text",Info_dia)
CompInit text3
proto="text3"
readOnly=1
sizeHControl=2
sizeVControl=2
maxChars=200
End CompInit
text3.name="text3"
text3.AppendString("(c) P. Cunrady 1998\r")
text3.AppendString("\r")
text3.AppendString("Email: peercunrady@online-club.de\r")
text3.AppendString("\r")
text3.AppendString("Version:  0.21")
text3.visible=1
Info_dia.height=99
Info_dia.width=233
Info_dia.name="Info_dia"
Dim dialog2 as dialog
dialog2 = MakeComponent("dialog","app")
CompInit dialog2
proto="dialog2"
left=421
top=160
tile=1
tileLayout=1
caption="Colorlist"
tileHAlign=1
helpContext=""
End CompInit
Dim group15 as group
group15 = MakeComponent("group",dialog2)
CompInit group15
proto="group15"
caption="group15"
look=2
tile=1
sizeHControl=3
sizeVControl=2
tileVAlign=1
visible=1
End CompInit
Dim list1 as list
list1 = MakeComponent("list",group15)
CompInit list1
proto="list1"
behavior=0
look=1
sizeHControl=2
sizeVControl=1
End CompInit
list1.name="list1"
list1.visible=1
Dim entry1 as entry
entry1 = MakeComponent("entry",group15)
CompInit entry1
proto="entry1"
visible=1
End CompInit
entry1.name="entry1"
group15.name="group15"
Dim group10 as group
group10 = MakeComponent("group",dialog2)
CompInit group10
proto="group10"
caption="group10"
look=2
tile=1
tileHAlign=2
sizeHControl=3
sizeVControl=2
tileVAlign=2
visible=1
End CompInit
Dim add_but as button
add_but = MakeComponent("button",group10)
CompInit add_but
proto="add_but"
caption="Add Item"
sizeHControl=2
sizeVControl=3
visible=1
End CompInit
add_but.name="add_but"
Dim ins_but as button
ins_but = MakeComponent("button",group10)
CompInit ins_but
proto="ins_but"
caption="Insert Item"
sizeHControl=2
sizeVControl=3
visible=1
End CompInit
ins_but.name="ins_but"
Dim Change_but as button
Change_but = MakeComponent("button",group10)
CompInit Change_but
proto="Change_but"
caption="Change Item"
sizeHControl=2
sizeVControl=3
visible=1
End CompInit
Change_but.name="Change_but"
Dim del_but as button
del_but = MakeComponent("button",group10)
CompInit del_but
proto="del_but"
caption="Delete Item"
sizeHControl=2
sizeVControl=3
visible=1
End CompInit
del_but.name="del_but"
Dim spacer3 as spacer
spacer3 = MakeComponent("spacer",group10)
CompInit spacer3
proto="spacer3"
sizeHControl=2
height=5
visible=1
End CompInit
spacer3.name="spacer3"
Dim delall_but as button
delall_but = MakeComponent("button",group10)
CompInit delall_but
proto="delall_but"
caption="Delete All"
sizeHControl=2
sizeVControl=3
visible=1
End CompInit
delall_but.name="delall_but"
Dim spacer4 as spacer
spacer4 = MakeComponent("spacer",group10)
CompInit spacer4
proto="spacer4"
height=5
visible=1
End CompInit
spacer4.name="spacer4"
Dim Write_but as button
Write_but = MakeComponent("button",group10)
CompInit Write_but
proto="Write_but"
caption="Write to file ..."
sizeHControl=2
sizeVControl=3
visible=1
End CompInit
Write_but.name="Write_but"
group10.name="group10"
dialog2.height=180
dialog2.width=280
dialog2.name="dialog2"
dialog2.focus=entry1
Dim dialog3 as dialog
dialog3 = MakeComponent("dialog","app")
CompInit dialog3
proto="dialog3"
left=442
top=422
tile=1
caption="16 Color Control"
tileSpacing=5
type=1
helpFile="colViz"
helpContext="TOC"
End CompInit
Dim group14 as group
group14 = MakeComponent("group",dialog3)
CompInit group14
proto="group14"
caption="group14"
tile=1
tileLayout=1
look=2
visible=1
End CompInit
Dim choice1 as choice
choice1 = MakeComponent("choice",group14)
CompInit choice1
proto="choice1"
caption=""
look=1
visible=1
End CompInit
choice1.graphic=GetComplex(3)
choice1.name="choice1"
Dim choice2 as choice
choice2 = MakeComponent("choice",group14)
CompInit choice2
proto="choice2"
caption=""
look=1
visible=1
End CompInit
choice2.graphic=GetComplex(4)
choice2.name="choice2"
Dim choice3 as choice
choice3 = MakeComponent("choice",group14)
CompInit choice3
proto="choice3"
caption=""
look=1
sizeHControl=0
sizeVControl=3
width=19
visible=1
End CompInit
choice3.graphic=GetComplex(5)
choice3.name="choice3"
Dim choice4 as choice
choice4 = MakeComponent("choice",group14)
CompInit choice4
proto="choice4"
caption=""
look=1
sizeHControl=0
sizeVControl=0
width=12
height=16
visible=1
End CompInit
choice4.graphic=GetComplex(6)
choice4.name="choice4"
Dim choice5 as choice
choice5 = MakeComponent("choice",group14)
CompInit choice5
proto="choice5"
caption=""
look=1
visible=1
End CompInit
choice5.graphic=GetComplex(7)
choice5.name="choice5"
Dim choice6 as choice
choice6 = MakeComponent("choice",group14)
CompInit choice6
proto="choice6"
caption=""
look=1
visible=1
End CompInit
choice6.graphic=GetComplex(8)
choice6.name="choice6"
Dim choice7 as choice
choice7 = MakeComponent("choice",group14)
CompInit choice7
proto="choice7"
caption=""
look=1
sizeHControl=0
sizeVControl=0
width=16
height=18
visible=1
End CompInit
choice7.graphic=GetComplex(9)
choice7.name="choice7"
Dim choice8 as choice
choice8 = MakeComponent("choice",group14)
CompInit choice8
proto="choice8"
caption=""
look=1
sizeHControl=0
sizeVControl=0
width=17
height=20
visible=1
End CompInit
choice8.graphic=GetComplex(10)
choice8.name="choice8"
Dim choice9 as choice
choice9 = MakeComponent("choice",group14)
CompInit choice9
proto="choice9"
caption=""
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
choice9.graphic=GetComplex(11)
choice9.name="choice9"
Dim choice10 as choice
choice10 = MakeComponent("choice",group14)
CompInit choice10
proto="choice10"
caption=""
look=1
sizeHControl=0
sizeVControl=0
width=13
height=20
visible=1
End CompInit
choice10.graphic=GetComplex(12)
choice10.name="choice10"
Dim choice11 as choice
choice11 = MakeComponent("choice",group14)
CompInit choice11
proto="choice11"
caption=""
look=1
sizeHControl=0
sizeVControl=0
width=16
height=16
visible=1
End CompInit
choice11.graphic=GetComplex(13)
choice11.name="choice11"
Dim choice12 as choice
choice12 = MakeComponent("choice",group14)
CompInit choice12
proto="choice12"
caption=""
look=1
visible=1
End CompInit
choice12.graphic=GetComplex(14)
choice12.name="choice12"
Dim choice13 as choice
choice13 = MakeComponent("choice",group14)
CompInit choice13
proto="choice13"
caption=""
look=1
visible=1
End CompInit
choice13.graphic=GetComplex(15)
choice13.name="choice13"
Dim choice14 as choice
choice14 = MakeComponent("choice",group14)
CompInit choice14
proto="choice14"
caption=""
look=1
visible=1
End CompInit
choice14.graphic=GetComplex(16)
choice14.name="choice14"
Dim choice15 as choice
choice15 = MakeComponent("choice",group14)
CompInit choice15
proto="choice15"
caption=""
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
choice15.graphic=GetComplex(17)
choice15.name="choice15"
Dim choice16 as choice
choice16 = MakeComponent("choice",group14)
CompInit choice16
proto="choice16"
caption=""
look=1
sizeHControl=0
sizeVControl=3
width=15
visible=1
End CompInit
choice16.graphic=GetComplex(18)
choice16.name="choice16"
group14.name="group14"
dialog3.name="dialog3"
dialog3.width=338
dialog3.height=1
dialog3.focus=choice1
Dim Write_Dia as dialog
Write_Dia = MakeComponent("dialog","app")
CompInit Write_Dia
proto="Write_Dia"
left=517
top=1
tile=1
caption="Write to file"
tileSpacing=5
helpContext=""
End CompInit
Dim Wr_Options_Gr as group
Wr_Options_Gr = MakeComponent("group",Write_Dia)
CompInit Wr_Options_Gr
proto="Wr_Options_Gr"
caption="Write Options"
look=1
sizeHControl=2
sizeVControl=3
tile=1
tileHAlign=2
visible=1
End CompInit
Dim NB_Code as choice
NB_Code = MakeComponent("choice",Wr_Options_Gr)
CompInit NB_Code
proto="NB_Code"
caption="NewBasic Code"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
NB_Code.name="NB_Code"
Wr_Options_Gr.name="Wr_Options_Gr"
Dim group16 as group
group16 = MakeComponent("group",Write_Dia)
CompInit group16
proto="group16"
caption="Filename:"
tileLayout=1
tile=1
sizeHControl=2
sizeVControl=3
tileHAlign=3
visible=1
End CompInit
Dim Fnameentry as entry
Fnameentry = MakeComponent("entry",group16)
CompInit Fnameentry
proto="Fnameentry"
visible=1
End CompInit
Fnameentry.name="Fnameentry"
group16.name="group16"
Dim spacer2 as spacer
spacer2 = MakeComponent("spacer",Write_Dia)
CompInit spacer2
proto="spacer2"
look=4
sizeHControl=2
visible=1
End CompInit
spacer2.name="spacer2"
Dim group17 as group
group17 = MakeComponent("group",Write_Dia)
CompInit group17
proto="group17"
caption="group17"
look=2
tile=1
tileLayout=1
tileSpacing=40
sizeHControl=2
sizeVControl=3
visible=1
End CompInit
Dim Wr_Ok_But as button
Wr_Ok_But = MakeComponent("button",group17)
CompInit Wr_Ok_But
proto="Wr_OK_But"
caption="OK"
sizeHControl=3
sizeVControl=3
closeDialog=1
visible=1
End CompInit
Wr_Ok_But.name="Wr_Ok_But"
Dim Wr_Canc_But as button
Wr_Canc_But = MakeComponent("button",group17)
CompInit Wr_Canc_But
proto="Wr_Canc_but"
caption="Cancel"
sizeHControl=3
sizeVControl=3
cancel=1
closeDialog=1
visible=1
End CompInit
Wr_Canc_But.name="Wr_Canc_But"
group17.name="group17"
Write_Dia.name="Write_Dia"
Write_Dia.width=280
Write_Dia.height=139
Write_Dia.focus=Fnameentry
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here
REM DIM NBPfile AS COMPONENT
REM NBPfile = MakeComponent("file","top")

REM This struct saves the complete UI-contents

STRUCT colorStruct
	DIM varName 	AS STRING
	DIM NBcolor	AS STRING
	DIM SDK		AS STRING
	DIM CNumber	AS INTEGER
	DIM RED		AS LONG
	DIM GREEN		AS LONG
	DIM BLUE		AS LONG
	DIM OPAC		AS LONG
END STRUCT

DIM LCounter 			AS INTEGER
DIM Liste[32]			AS STRUCT colorStruct
DIM ColNumberOffset 	AS INTEGER

ColNumberOffset = 40 REM wir starten immer im 216er Modus

form1.visible = TRUE
end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
REM form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

form1.visible = 0

end sub

sub collect()
REM Diese SUB wird aufgerufen, wenn sich bei den RGB-Werten und Opacity
REM vom User ausgelste nderungen ergaeben haben.
REM 
REM wird aufgerufen von:	number_x_changed ()
REM								gadget1_Draw ()
REM
REM	ruft auf:					NBColorNumber (LONG,LONG,LONG,LONG)
REM								SDK_Color_String (LONG,LONG,LONG)


DIM Color		AS LONG
DIM RedComp	AS LONG
DIM GreenComp	AS LONG
DIM BlueComp	AS LONG
DIM OpacComp	AS LONG

RedComp	= number1.value
GreenComp	= number2.value
BlueComp	= number3.value
OpacComp	= number4.value

NBColorNumber (OpacComp,RedComp,GreenComp,BlueComp) REM Display NB_Color_Number
SDK_Color_String(RedComp,GreenComp,BlueComp)


drawing() REM Draws the Prewview

end sub

sub number1_changed(self as number, value as integer)
collect()
end sub

sub number2_changed(self as number, value as integer)
collect()
end sub

sub number3_changed(self as number, value as integer)
collect()
end sub

sub number4_changed(self as number, value as integer)
collect()
end sub

function NullFormat ( Color AS STRING) AS STRING
REM Diese Routine dient einfach zur Formatierung des HexStrings des NBfarbwertes
REM es wird sichergestellt, das fhrende Nullen nicht unterschlagen werden.
REM Funktionsaufruf durch: NBColorNumber()

		IF LEN (Color) = 1 THEN

			NullFormat = "0" + Color

		ELSE

			NullFormat = Color

		END IF

end function

function ColorNumber (opacity AS LONG, red AS LONG, green AS LONG, blue AS LONG ) AS LONG
REM Hier wird die NB Farbe aus ihren vier Einzelkomponenten zusammengesetzt.

DIM SevenByte	AS LONG
DIM FiveByte	AS LONG
DIM ThreeByte	AS LONG


SevenByte	= &H1000000
FiveByte	= &H10000
ThreeByte	= &H100

ColorNumber = (opacity * SevenByte) + (red * FiveByte) + (green * ThreeByte) + blue

end function

sub gadget1_draw(self as gadget)
collect()

end sub

sub SDK_Color_String (red AS LONG, green AS LONG, blue AS LONG)
DIM ColorString	AS STRING
DIM C_Number		AS INTEGER

REM Hier wird darauf geachtet, das der SDK-String nur ausgegeben wird, wenn die Farbe Teil
REM der GEOS-256 Farbentabelle ist

IF red MOD 51 = 0 THEN
	
	IF green MOD 51 = 0 THEN
				
		IF blue MOD 51 = 0 THEN
				
			ColorString =	"C_R" + STR (red/51) + "_" + 	"G" + STR (green/51) + "_" + "B" + STR (blue/51)
		
		ELSE 

			ColorString = "-"		

		END IF

	ELSE

		ColorString = "-"
	
	END IF

ELSE

	ColorString = "-"

END IF

REM C_Number
REM Hallo Dirk, da bist Du mir mit der Verffentlichung Deines RGB-Programms
REM zuvor gekommen. Habe die Farbnummerberechnung von W. Koncynski aus Deinem
REM Code entliehen. Mu dazu sagen ich war beinahe auch soweit, das ich selbst
REM dahinter gekommen waere. Die Anordnung der Faben des SDK ist auch zu logisch
REM aufgebaut, als das man sie nicht berechnen knnte

C_Number = ((red/51)*36)+((green/51)*6)+((blue/51))+40


number5.value = C_Number

text1.ReplaceString (ColorString,0,10)
entry1.text = ColorString
end sub

sub NBColorNumber (Opac AS LONG, red AS LONG, green AS LONG, blue AS LONG)
REM Diese SUB erzeugt einen String der dem Zahlenwert entspricht den NB intern
REM zur Farbdarstellung verwendet. Der String wird aber lediglich zur Ausgabe in
REM text2 benutzt.
REM
REM	aufgerufen von:	Collect()
REM
REM ruft auf:			NullFromat(STRING)


DIM RedCompHex	AS STRING
DIM GreenCompHex	AS STRING
DIM BlueCompHex	AS STRING
DIM OpacCompHex	AS STRING
DIM ColorString	AS STRING

RedCompHex		= HEX (red)
GreenCompHex	= HEX (green)
BlueCompHex	= HEX (blue)
OpacCompHex	= HEX (Opac)

RedCompHex 	= NullFormat (RedCompHex)
GreenCompHex	= NullFormat (GreenCompHex)
BlueCompHex	= NullFormat (BlueCompHex)
OpacCompHex	= NullFormat (OpacCompHex)

ColorString = "&H" + OpacCompHex + RedCompHex + GreenCompHex + BlueCompHex
text2.ReplaceString (ColorString,0,10)
end sub

sub list1_changed(self as list, index as integer)
REM Diese SUB wird automatisch vom System aufgerufen, wenn sich in der Liste
REM nderungen ergeben.
REM 
REM ruft auf:	SetColorTripleValue (INT,INT,INT,STRING)
REM				Drawing()

DIM Color 		AS LONG
DIM RLCounter	AS INTEGER	
REM		Dieser Zhler darf nicht mit dem norm. Listenzhler
REM	 	'LCounter' kollidieren

RLCounter = list1.selectedItem

IF RLCounter > -1 THEN
	
	entry1.text			= 	Liste[RLCounter].varName
	
	text2.ReplaceString 	(	Liste[RLCounter].NBcolor,		\
								0, 									\
								LEN(Liste[RLCounter].NBcolor)	\
							)
	
	text1.ReplaceString	(	Liste[RLCounter].SDK,			\
								0,									\
								LEN(Liste[RLCounter].SDK)		\
							)
	number5.value			= 	Liste[RLCounter].CNumber
	
	SetColorTripleValue 	(	Liste[RLCounter].RED,	\
								Liste[RLCounter].GREEN,	\
								Liste[RLCounter].BLUE	\
							)

	number4.value			= 	Liste[RLCounter].OPAC

END IF



drawing ()

end sub

sub button4_pressed(self as button)
Info_dia.visible = TRUE
end sub

sub drawing ()
REM Draws the preview
DIM Color		AS LONG
DIM ColorR		AS LONG
DIM ColorG		AS LONG
DIM ColorB		AS LONG
DIM RED		AS INTEGER
DIM BLUE		AS INTEGER
DIM GREEN		AS INTEGER
DIM OPAC		AS LONG

Color = ColorNumber	(	number4.value,	\
                    		number1.value,	\
                    		number2.value,	\
							number3.value		\
						)

REM RED = 0 ? ********************************************
IF number1.value = 0 THEN

	RED 	= 170
	GREEN	= 170
	BLUE	= 170

ELSE
	
	RED		= number1.value
	GREEN	= 0
	BLUE	= 0

END IF

ColorR = ColorNumber	(	255,				\
                    		RED,				\
                    		GREEN,				\
							BLUE				\
						)

REM GREEN = 0 ? ********************************************
IF number2.value = 0 THEN

	RED 	= 170
	GREEN	= 170
	BLUE	= 170

ELSE
	RED			= 0
	GREEN		= number2.value
	BLUE		= 0

END IF

ColorG = ColorNumber	(	255,	\
                    		RED,	\
                    		GREEN,	\
							BLUE	\
						)
REM BLUE = 0 ? ********************************************

IF number3.value = 0 THEN

	RED 	= 170
	GREEN	= 170
	BLUE	= 170

ELSE
	
	RED		= 0
	GREEN	= 0
	BLUE	= number3.value

END IF

ColorB = ColorNumber	(	255,		\
                    		RED,		\
                    		GREEN,		\
							BLUE		\
						)

OPAC 	= ColorNumber	(	number4.value,	\
							0,					\
							0,					\
							0					\
						)



Preview.DrawRect (0,0,clipper1.width,clipper1.height,WHITE)
Preview.DrawRect (0,0,clipper1.width,clipper1.height,Color)

gadget2.DrawRect (0,0,gadget2.width,gadget2.height,ColorR)
gadget2.DrawText ("R",3,0,WHITE,".",13,0)

gadget3.DrawRect (0,0,gadget3.width,gadget2.height,ColorG)
gadget3.DrawText ("G",3,0,WHITE,".",13,0)

gadget4.DrawRect (0,0,gadget4.width,gadget2.height,ColorB)
gadget4.DrawText ("B",3,0,WHITE,".",13,0)

gadget5.DrawRect	(0,0,gadget5.width,gadget5.height,WHITE)
gadget5.DrawRect	(0,0,gadget5.width,gadget5.height,OPAC)
gadget5.DrawText ("O",3,0,WHITE,".",13,0)

gadget6.DrawText ("#",3,1,WHITE,".",18,0)

end sub

sub number5_changed(self as number, value as integer)
DIM SDKColorValue 	AS INTEGER
DIM greenDummy		AS INTEGER

SDKColorValue			= number5.value - ColNumberOffset

number1.value			= INT ( ( SDKColorValue / 36 ) * 51 )
greenDummy				= SDKColorValue MOD 36
number2.value			= INT ( greenDummy / 6 ) * 51
number3.value			= ( greenDummy MOD 6 )	* 51

NBColorNumber (number4.value,number1.value,number2.value,number3.value)
SDK_Color_String(number1.value,number2.value,number3.value)

drawing()

end sub

sub gadget4_draw(self as gadget)
drawing()
end sub

sub gadget3_draw(self as gadget)
drawing()
end sub

sub gadget2_draw(self as gadget)
drawing()
end sub

sub button6_pressed(self as button)
number1.increment = 0
number2.increment = 0
number3.increment = 0
dialog3.visible = TRUE

end sub

sub button9_pressed(self as button)
DIM IncMilCol AS INTEGER

IncMilCol = 1


number1.increment = IncMilCol
number2.increment = IncMilCol
number3.increment = IncMilCol

end sub

sub button7_pressed(self as button)
DIM Inc256	AS INTEGER

Inc256 = 51
number1.increment = Inc256
number2.increment = Inc256
number3.increment = Inc256

number1.value = int (number1.value/Inc256) * Inc256
number2.value = int (number2.value/Inc256) * Inc256
number3.value = int (number3.value/Inc256) * Inc256

end sub

sub button12_pressed(self as button)

end sub

sub choiceSelect (Choice_Number AS INTEGER)
REM Diese SUB steuert die Ausgabe der RGB-Werte und des SDK - Farbnamens
REM aufgerufen von:	CHOICEX()
REM
REM Datum:				01.04.98
REM ruft auf:			SetColorTripleValue (INT,INT,INT,STRING)
REM						Drawing()
REM						SetColorNumbers ()
REM gendert:			25.06.98


SELECT CASE Choice_Number
	
	CASE 1
		SetColorTripleValue (0,0,0)
		SetColorNumbers ( 2 , "C_BLACK" )
	CASE 2
		SetColorTripleValue (0,0,170)
		SetColorNumbers ( 2 , "C_BLUE" )
	CASE 3
		SetColorTripleValue (0,170,0)
		SetColorNumbers ( 3 , "C_GREEN" )
	CASE 4
		SetColorTripleValue (0,170,170)
		SetColorNumbers ( 4 , "C_CYAN" )
	CASE 5
		SetColorTripleValue (170,0,0)
		SetColorNumbers ( 5 , "C_RED" )
	CASE 6
		SetColorTripleValue (170,0,170)
		SetColorNumbers ( 6 , "C_VIOLET" )
	CASE 7
		SetColorTripleValue (170,85,0)
		SetColorNumbers ( 7 , "C_BROWN" )
	CASE 8
		SetColorTripleValue (170,170,170)
		SetColorNumbers ( 8 , "C_LIGHT_GRAY" )
	CASE 9
		SetColorTripleValue (85,85,85)
		SetColorNumbers ( 9 , "C_DARK_GRAY" )
	CASE 10
		SetColorTripleValue (85,85,255)
		SetColorNumbers ( 10 , "C_LIGHT_BLUE" )
	CASE 11
		SetColorTripleValue (85,255,85)
		SetColorNumbers ( 11 , "C_LIGHT_GREEN" )
	CASE 12
		SetColorTripleValue (85,255,255)
		SetColorNumbers ( 12 , "C_LIGHT_CYAN" )
	CASE 13
		SetColorTripleValue (255,85,85)
		SetColorNumbers ( 13 , "C_LIGHT_RED" )
	CASE 14
		SetColorTripleValue (255,85,255)
		SetColorNumbers ( 14 , "C_LIGHT_VIOLET" )
	CASE 15
		SetColorTripleValue (255,255,85)
		SetColorNumbers ( 15 , "C_YELLOW" )
	CASE 16
		SetColorTripleValue (255,255,255)
		SetColorNumbers ( 16 , "C_WHITE" )
END SELECT

		drawing()




end sub

sub choice1_changed(self as choice)
DIM Black_Choice AS INTEGER

Black_Choice = 1

choiceSelect (Black_Choice)

end sub

sub choice2_changed(self as choice)
DIM DBlue_Choice AS INTEGER

DBlue_Choice = 2

choiceSelect (DBlue_Choice)
end sub

sub choice3_changed(self as choice)
DIM DGreen_Choice AS INTEGER

DGreen_Choice = 3

choiceSelect (DGreen_Choice)

end sub

sub choice4_changed(self as choice)
DIM Cyan_Choice AS INTEGER

Cyan_Choice = 4

choiceSelect (Cyan_Choice)
end sub

sub choice5_changed(self as choice)
DIM DRed_Choice AS INTEGER

DRed_Choice = 5

choiceSelect (DRed_Choice)
end sub

sub choice6_changed(self as choice)
DIM Flieder_Choice AS INTEGER

Flieder_Choice = 6

choiceSelect (Flieder_Choice)
end sub

sub choice7_changed(self as choice)
DIM Brown_Choice AS INTEGER

Brown_Choice = 7

choiceSelect (Brown_Choice)
end sub

sub choice8_changed(self as choice)
DIM Gray_Choice AS INTEGER

Gray_Choice = 8

choiceSelect (Gray_Choice)
end sub

sub choice9_changed(self as choice)
DIM DGray_Choice AS INTEGER

DGray_Choice = 9

choiceSelect (DGray_Choice)
end sub

sub choice10_changed(self as choice)
DIM Blue_Choice AS INTEGER

Blue_Choice = 10

choiceSelect (Blue_Choice)
end sub

sub SetColorTripleValue (red AS INTEGER, green AS INTEGER, blue AS INTEGER)
REM setzt die Farbwerte von:	number1, number2 und number3 und text1
REM wird aufgerufen durch:		choiceSelect (), list1.changed ()
	
	number1.value = red
	number2.value = green
	number3.value = blue

end sub

sub choice11_changed(self as choice)
DIM LGreen_Choice AS INTEGER

LGreen_Choice = 11

choiceSelect (LGreen_Choice)
end sub

sub choice12_changed(self as choice)
DIM LBlue_Choice AS INTEGER

LBlue_Choice = 12

choiceSelect (LBlue_Choice)
end sub

sub choice13_changed(self as choice)
DIM LRed_Choice AS INTEGER

LRed_Choice = 13

choiceSelect (LRed_Choice)
end sub

sub choice14_changed(self as choice)
DIM LPurple_Choice AS INTEGER

LPurple_Choice = 14

choiceSelect (LPurple_Choice)
end sub

sub choice15_changed(self as choice)
DIM Yellow_Choice AS INTEGER

Yellow_Choice = 15

choiceSelect (Yellow_Choice)
end sub

sub choice16_changed(self as choice)
DIM White_Choice AS INTEGER

White_Choice = 16

choiceSelect (White_Choice)
end sub

sub Colorlist_pressed(self as button)

dialog2.visible = TRUE

end sub

sub del_but_pressed(self as button)
REM Die Werte eines Listeneintrages knnen hier gendert werden

DIM LItem AS INTEGER

LItem = list1.selectedItem




list1.Delete(LItem) REM Einzelnen Listen Eintrag lschen
LCounter = LCounter - 1
end sub

sub add_but_pressed(self as button)
REM Hier wird der Inhalt des UI in der Structurvar. Liste... abgespeichert

Liste[LCounter].varName	= entry1.text
Liste[LCounter].NBcolor	= text2.GetString (0,text2.numChars)
Liste[LCounter].SDK		= text1.GetString (0,text1.numChars)
Liste[LCounter].CNumber	= number5.value
Liste[LCounter].RED 		= number1.value
Liste[LCounter].GREEN	= number2.value
Liste[LCounter].BLUE		= number3.value
Liste[LCounter].OPAC		= number4.value
list1.captions[LCounter] = Liste[LCounter].varName
LCounter = LCounter + 1

	IF LCounter = 10 THEN				REM nicht mehr als 10 Listeneintrge
		add_but.enabled = FALSE
	END IF

end sub

sub Write_but_pressed(self as button)

Write_Dia.visible = TRUE

end sub

sub Preview_draw(self as gadget)
collect()

end sub

sub Color16_but_pressed(self as button)
DIM Increment AS INTEGER

ColNumberOffset		= 0
Increment				= 0

number1.increment	= Increment
number2.increment	= Increment
number3.increment	= Increment

dialog3.visible		= TRUE
form1.caption			= "ColorWiz 0.2 16 Colors"

end sub

sub ColorMil_but_pressed(self as button)
DIM Increment	AS	INTEGER

Increment				=	1
ColNumberOffset		=	0

number1.increment	=	Increment
number2.increment 	=	Increment
number3.increment 	=	Increment

dialog3.visible		=	FALSE
form1.caption			=	"ColorWiz 0.2 Mil Colors"

end sub

sub Color216_but_pressed(self as button)
DIM Increment	AS	INTEGER
DIM RDummy		AS	INTEGER
DIM GDummy		AS	INTEGER
DIM BDummy		AS	INTEGER

Increment				= 51

number1.value			= INT ( number1.value / Increment ) * Increment
number2.value			= INT ( number2.value / Increment ) * Increment
number3.value			= INT ( number3.value / Increment ) * Increment

ColNumberOffset 		= 40 REM Nur SDKFarbnummern ab 40 sind in diesem Modus erlaubt

number1.increment 	= Increment
number2.increment 	= Increment
number3.increment 	= Increment

dialog3.visible 		= FALSE
form1.caption 		= "ColorWiz 0.2 216 Colors"

end sub

sub SetColorNumbers (Number AS INTEGER, C_Entry AS STRING)
REM setzt die Farbnummer, den SDK Farbstring und das eingabefeld der
REM Liste.
REM Datum:						25.06.98
REM aufgerufen durch:		ChoiceSelect ()
REM 
		number5.value			= Number
		entry1.text			= C_Entry
		text1.ReplaceString	( C_Entry , 0 , 30 )

end sub

sub Change_but_pressed(self as button)
REM Die Werte eines Listeneintrages knnen hier gendert werden

DIM LItem AS INTEGER

LItem = list1.selectedItem


Liste[LItem].varName	= entry1.text
Liste[LItem].NBcolor	= text2.GetString (0,text2.numChars)
Liste[LItem].SDK		= text1.GetString (0,text1.numChars)
Liste[LItem].CNumber	= number5.value
Liste[LItem].RED 	= number1.value
Liste[LItem].GREEN	= number2.value
Liste[LItem].BLUE	= number3.value
Liste[LItem].OPAC	= number4.value

list1.captions[LItem] = Liste[LItem].varName

end sub

sub delall_but_pressed(self as button)
REM hier mu noch eine sicherheitsabfrage rein

list1.Clear()
LCounter = 0 REM Liste soll schlielich wieder oben anfangen


end sub

